#include <fstream.h>
#include "defs.h"
typedef union  {
  int   in;
  char *ch;
} YYSTYPE;
#define DRAW 257
#define DEFINE 258
#define LINE 259
#define BOX 260
#define ELLIPSE 261
#define POLYGON 262
#define OUTLINED 263
#define SOLID 264
#define DOTTED 265
#define WHITE 266
#define GRAY 267
#define BLACK 268
#define RED 269
#define GREEN 270
#define BLUE 271
#define IDENTIFIER 272
#define INTEGER 273
YYSTYPE yylval, yyval;
#define YYERRCODE 256

const int yyexca[] = {
  -1, 1,
  0, -1,
  -2, 0,
  0,
};

#define YYNPROD 28
#define YYLAST 232

const int yyact[] = {
      19,      12,      13,      15,      14,      34,      37,      16,
      12,      13,      15,      14,       5,       6,       9,      18,
       8,       7,      35,      33,      10,      36,      22,      21,
      20,      32,      17,      11,       4,       3,       2,       1,
       0,       0,       0,       0,       0,       0,       0,      31,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
      38,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
      23,      24,      25,      26,      27,      28,      29,      30,
};

const int yypact[] = {
   -4096,    -245,   -4096,     -42,     -43,    -258,    -265,   -4096,
   -4096,   -4096,   -4096,   -4096,   -4096,   -4096,   -4096,   -4096,
     -46,     -40,    -251,    -268,   -4096,   -4096,   -4096,   -4096,
   -4096,   -4096,   -4096,   -4096,   -4096,   -4096,   -4096,   -4096,
     -23,   -4096,    -267,   -4096,    -268,   -4096,   -4096,
};

const int yypgo[] = {
       0,      31,      30,      29,      28,      20,      27,      26,
      25,      24,      23,      22,      19,
};

const int yyr1[] = {
       0,       1,       1,       2,       2,       3,       3,       4,
       5,       6,       6,       6,       6,       7,       7,       9,
       9,      10,      10,      11,      11,      11,      11,      11,
      11,       8,       8,      12,
};

const int yyr2[] = {
       0,       0,       2,       2,       2,       2,       2,       4,
       5,       1,       1,       1,       1,       0,       2,       1,
       1,       1,       1,       1,       1,       1,       1,       1,
       1,       1,       3,       2,
};

const int yychk[] = {
   -4096,      -1,      -2,      -3,      -4,     257,     258,      59,
      59,     272,      -5,      -6,     259,     260,     262,     261,
     272,      -7,      61,      40,      -9,     -10,     -11,     264,
     265,     266,     267,     268,     269,     270,     271,      -5,
      -8,     -12,     273,      41,      44,     273,     -12,
};

const int yydef[] = {
       1,      -2,       2,       0,       0,       0,       0,       3,
       4,       5,       6,      13,       9,      10,      11,      12,
       0,       0,       0,       0,      14,      15,      16,      17,
      18,      19,      20,      21,      22,      23,      24,       7,
       0,      25,       0,       8,       0,      27,      26,
};

/*
 ============================================================================
  Parser.h: A C++ LALR(1) parser driver with syntax error diagnostics.

  By Loren Cobb, Corrales Software, Corrales, NM 87048-2730.
  
  Copyright (c) 1989-92 by Abraxas Software Inc. (R).  All rights reserved.
 ============================================================================
*/  


#include "tparser.h"

int TParser::yyparse( void )
	{
	YYSTYPE		*yypvt,
				*yypv;
				
	int		yys[YYMAXDEPTH],
				yyj, yym, yystate,
				*yyps, yyn, *yyxi;

	yystate = 0;
	yytoken = -1;
	errct = 0;
	errfl = 0;
	yyps = yys - 1;
	yypv = yyv - 1;

yystack: 		/* put a state and value onto the stack */

	 if ( ++yyps > yys + YYMAXDEPTH )
		{
		yymessage( FATAL, 0 );		/*	This condition is fatal	*/
		}
	 *yyps = yystate;
     ++yypv;
     *yypv = yyval;

yynewstate:

	yyn = yypact[yystate];

	if ( yyn <= YYFLAG )
		goto yydefault;		/* simple state with only default action */

	if ( yytoken < 0 )		/* no lookahead token? */
		{
		yytoken = yylex();
		if ( yytoken < 0 )
			yytoken = 0;
		}

	yyn += yytoken;
	if ( yyn < 0 || yyn >= YYLAST )		/*	no entry within table?					*/
		goto yydefault;					/*	simple state with only default action	*/

	if ( yychk[yyn = yyact[yyn]] == yytoken )		/*	valid shift?		*/
		{
		yytoken = -1;			/*	lookahead token is read	*/
		yyval = yylval;
		yystate = yyn;
		if ( errfl > 0 )		/*	still in error state?		*/
			--errfl;
		goto yystack;
		}

yydefault:		/* simple state with only default action */

	if ( (yyn = yydef[yystate]) == -2 )
     		{
		if ( yytoken < 0 )		/* no lookahead token? */
			{
			yytoken = yylex();
			if ( yytoken < 0 )
				yytoken = 0;
			}

		/*	Look through exception table:	*/
		
		for ( yyxi = (int *)yyexca; *yyxi != -1 || yyxi[1] != yystate; yyxi += 2 )
			;		/* VOID */
		while ( *(yyxi += 2) >= 0 )
			{
			if ( *yyxi == yytoken )
				break;
			}
		if ( (yyn = yyxi[1]) < 0 )
			return 0;				/*	accept	*/
		}

	if ( yyn == 0 )			/*	error?	*/
		{
		switch( errfl )
			{
		case 0:			/*	brand new error	*/
			yymessage( START, yytoken );
			yyn = yypact[yystate];
			if ( (yyn > YYFLAG) && (yyn < YYLAST) )
				{
				register int	x;

				for ( x = (yyn > 0) ? yyn : 0; x < YYLAST; ++x )
					if ( yychk[yyact[x]] == x - yyn )
						yymessage( EXPECT, x - yyn );
				}
			yymessage( SENDIT, 0 );
			++errct;

		case 1:
		case 2:		/*	Incompletely recovered error ... try again:		*/
			errfl = 3;
					/*	Find a state where "error" is a legal shift action:	*/
			while ( yyps >= yys )
				{
				yyn = yypact[*yyps] + YYERRCODE;
				if ( (yyn >= 0) && (yyn < YYLAST) && (yychk[yyact[yyn]] == YYERRCODE) )
					{
					yystate = yyact[yyn];	/*	Simulate a shift of "error"	*/
					goto yystack;
					}
				yyn = yypact[*yyps];
				
				--yyps;		/*	The current yyps has no shift on "error",	*/
				--yypv;		/*	so pop the stack.							*/
				}

			/*
				There is no state on the stack with an error shift,
				so abort:
			*/
yyabort:
			return 1;

		case 3:						/*	No shift yet; clobber input char:	*/
			if ( yytoken == 0 )		/*	EOF?								*/
				goto yyabort;		/*	Don't discard EOF, quit instead.	*/
			yytoken = -1;
			goto yynewstate;		/*	Try again in the same state	.		*/
			}
		}

	/*	Reduction by production yyn:	*/

	yyps -= yyr2[yyn];
	yypvt = yypv;
	yypv -= yyr2[yyn];
	yyval = yypv[1];
	yym = yyn;
    
	/*	Consult goto table to find next state:	*/

	yyn = yyr1[yyn];
	yyj = yypgo[yyn] + *yyps + 1;
	if ( (yyj >= YYLAST) || (yychk[yystate = yyact[yyj]] != -yyn) )
		yystate = yyact[yypgo[yyn]];
	switch ( yym )
		{
		
case 5:{ append_objlst(lookup(yypvt[-0].ch)); 
		  delete yylval.ch;
		} break;
case 6:{ append_objlst(new_object(&anObject)); } break;
case 7:{ install(yypvt[-2].ch, new_object(&anObject)); 
		} break;
case 9:{ anObject.shape = LINE; } break;
case 10:{ anObject.shape = BOX;  } break;
case 11:{ anObject.shape = POLYGON; } break;
case 12:{ anObject.shape = ELLIPSE; } break;
case 17:{ anObject.style = SOLID; } break;
case 18:{ anObject.style = DOTTED; } break;
case 19:{ anObject.color = RGB_WHITE; } break;
case 20:{ anObject.color = RGB_GRAY;  } break;
case 21:{ anObject.color = RGB_BLACK; } break;
case 22:{ anObject.color = RGB_RED;   } break;
case 23:{ anObject.color = RGB_GREEN; } break;
case 24:{ anObject.color = RGB_BLUE;  } break;
case 27:{
		anObject.x_coord[anObject.npoints  ] = yypvt[-1].in;
		anObject.y_coord[anObject.npoints++] = yypvt[-0].in;
		} break;
		}
	goto yystack;	/*	Stack new state and value	*/
	}

